/***************************************************************************
 *   Copyright (C) 2005 - 2007 by                                          *
 *      Christian Muehlhaeuser, Last.fm Ltd <chris@last.fm>                *
 *      Erik Jaelevik, Last.fm Ltd <erik@last.fm>                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02110-1301, USA.          *
 ***************************************************************************/

#ifndef WIZARDBOOTSTRAPASKPAGE_H
#define WIZARDBOOTSTRAPASKPAGE_H

#include "ui_BootstrapSelectorWidget.h"

#include "plugininfo.h"

class SimpleWizard;

class WizardBootstrapSelectorPage : public QWidget
{
    Q_OBJECT

public:
    WizardBootstrapSelectorPage(
        SimpleWizard*   wizard,
        const QString&  info );

    Ui::bootstrapSelectorWidget ui;
    void populate( std::vector<class CPluginInfo>& pluginList );

    CPluginInfo* selectedPlugin();

private:
    std::vector<CPluginInfo> mPlugins;

    friend class SimpleWizard;
};

Q_DECLARE_METATYPE(CPluginInfo*)

#endif // WIZARDBOOTSTRAPPAGE_H
